App GeoFeature

From FreeCAD Documentation
Jump to navigation Jump to search
This page is a translated version of the page App GeoFeature and the translation is 10% complete.
Other languages:
Deutsch • ‎English • ‎français • ‎italiano • ‎polski

Einleitung

Feature.svg

An App GeoFeature object, or formally an App::GeoFeature, is the base class of most objects that will display geometrical elements in the 3D view because it includes a DatenPlacement property.

FreeCAD core objects.svg

Simplified diagram of the relationships between the core objects in FreeCAD

Anwendung

The App GeoFeature is an internal object, so it cannot be created from the graphical interface. It is generally not meant to be used directly, rather it can be sub-classed to get a bare-bones object that only has a basic DatenPlacement property to define its position in the 3D view.

Some of the most important derived objects are the following:

When creating this object in Python, instead of sub-classing App::GeoFeature, you should sub-class App::GeometryPython because the latter includes a default view provider, and Proxy attributes for the object itself, and its view provider. See Scripting.

Properties App GeoFeature

See Property for all property types that scripted objects can have.

The App GeoFeature (App::GeoFeature class) is derived from the basic App DocumentObject (App::DocumentObject class) and inherits all its properties. In addition it has a DatenPlacement property, which controls its position in the 3D view.

Properties App GeometryPython

See Property for all property types that scripted objects can have.

The App GeometryPython (App::GeometryPython class) is derived from the basic App GeoFeature (App::GeoFeature class) and inherits all its properties. It also has several additional properties.

These are the properties available in the property editor. Hidden properties can be shown by using the Show all command in the context menu of the property editor.

Data

Base

  • Daten (Hidden)Proxy (PythonObject): a custom class associated with this object.
  • DatenPlacement (Placement): the position of the object in the 3D view. The placement is defined by a Base point (vector), and a Rotation (axis and angle). See Placement.
    • DatenAngle: the angle of rotation around the DatenAxis. By default, it is (zero degrees).
    • DatenAxis: the unit vector that defines the axis of rotation for the placement. Each component is a floating point value between 0 and 1. If any value is above 1, the vector is normalized so that the magnitude of the vector is 1. By default, it is the positive Z axis, (0, 0, 1).
    • DatenPosition: a vector with the 3D coordinates of the base point. By default, it is the origin (0, 0, 0).
  • DatenLabel (String): the user editable name of this object, it is an arbitrary UTF8 string.
  • Daten (Hidden)Label2 (String): a longer, user editable description of this object, it is an arbitrary UTF8 string that may include newlines. By default, it is an empty string "".
  • Daten (Hidden)Expression Engine (ExpressionEngine): a list of expressions. By default, it is empty [].
  • Daten (Hidden)Visibility (Bool): whether to display the object or not.

View

Base

  • Ansicht (Hidden)Proxy (PythonObject): a custom viewprovider class associated with this object.

Display Options

  • AnsichtBounding Box (Bool): if it is true, the object will show the bounding box in the 3D view.
  • AnsichtDisplay Mode (Enumeration): see the information in App FeaturePython.
  • AnsichtShow In Tree (Bool): see the information in App FeaturePython.
  • AnsichtVisibility (Bool): see the information in App FeaturePython.

Object Style

  • AnsichtShape Color (Color): a tuple of three floating point RGB values (r,g,b) to define the color of the faces in the 3D view; by default it is (0.8, 0.8, 0.8), which is displayed as [204, 204, 204] on base 255, a light gray .
  • Ansicht (Hidden)Shape Material (Material): an App Material associated with this object. By default it is empty.
  • AnsichtTransparency (Percent): an integer from 0 to 100 that determines the level of transparency of the faces in the 3D view. A value of 100 indicates completely invisible faces; the faces are invisible but they can still be picked as long as AnsichtSelectable is true.

Selection

  • AnsichtOn Top When Selected (Enumeration): see the information in App FeaturePython.
  • AnsichtSelectable (Bool): if it is true, the object can be picked with the pointer in the 3D view. Otherwise, the object cannot be selected until this option is set to true.
  • AnsichtSelection Style (Enumeration): see the information in App FeaturePython.

Scripting

See also: FreeCAD Scripting Basics and scripted objects.

See Part Feature for the general information on adding objects to the document.

A GeoFeature is created with the addObject() method of the document. If you would like to create an object with a 2D or 3D topological shape, it may be better to create one of the sub-classes specialized for handling shapes, for example Part Feature or Part Part2DObject.

import FreeCAD as App

doc = App.newDocument()
obj = App.ActiveDocument.addObject("App::GeoFeature", "Name")
obj.Label = "Custom label"

For Python subclassing you should create the App::GeometryPython object.

import FreeCAD as App

doc = App.newDocument()
obj = App.ActiveDocument.addObject("App::GeometryPython", "Name")
obj.Label = "Custom label"